/*************************************************************************
 * TLV 02/14/2002                                                        *
 * The cbreak() code was originally from                                 *
 * http://web.mit.edu/answers/c/c_getch.html                             *
 * which is apparently from the book "Advanced Programming in the UNIX   *
 * Environment" by W Richard Stevens                                     *
 *                                                                       *
 *************************************************************************/


#include "term_util.h"

/************************************************************************
 * This function was ripped off from                                    *
 * "Advanced Programming in the UNIX Environment"                       *
 * (see comments at top of program                                      *
 * This turns off echoing and line buffering (allow single characters   *      
 * w/o ENTER                                                            *
 * ICANON - canonical mode - buffers by lines                           *
 * ECHO - echo input characters                                         *
 * ECHOK - if ICANON on, KILL char erases the current line              *
 *                                                                      *
 * Returns:  -1 on failure, else 0                                      *
 ************************************************************************/
int cbreak(struct termios tty) {
   tty.c_lflag = tty.c_lflag & ~(ECHO | ECHOK | ICANON);
   tty.c_cc[VTIME] = 1;
   return (tcsetattr(STDIN_FILENO, TCSANOW, &tty));
}

